	

;----------------------------------------
IntroDemo
	;Intro demo
	CALL ClearScreenEffect
	CALL DrawFinalStage
	LD DE,BossStand
	LD BC,4*256+5
	LD HL,20557
	CALL DrawTile
	LD HL,16384+128
	LD DE,BossStartText
	CALL TypeText			
	
	;Color cycling for Text
	LD A,67
	LD C,140
StartColorCycle1	
	LD B,128
	LD HL,22528+128
	HALT
	HALT		
StartColorCycle2	
		LD (HL),A	
		INC L		
		DJNZ StartColorCycle2
	;swap Color
	CP 67
	JR Z,StartColorCycle3
	LD A,67
	JR StartColorCycle4	
StartColorCycle3
	LD A,71
StartColorCycle4
	DEC C
	JR NZ,StartColorCycle1				
	RET	
;----------------------
DrawFinalStage
	LD HL,18604
	LD DE,Pentagram
	LD BC,5*256+4
	CALL DrawTile

	LD HL,18596
	LD DE,Window
	LD BC,4*256+4
	PUSH BC
	PUSH DE
	CALL DrawTile
	POP DE
	POP BC
	LD HL,18613
	CALL DrawTile

;DrawTorches	
	LD HL,18624
	LD DE, Torch
	LD BC,2*256+3
	PUSH DE
	PUSH BC
	CALL DrawTile
	POP BC
	POP DE
	LD HL,18633
	PUSH BC
	PUSH DE
	CALL DrawTile
	POP DE
	POP BC
	LD HL,18642
	PUSH BC
	PUSH DE
	CALL DrawTile
	POP DE
	POP BC
	LD HL,18651
	PUSH BC
	PUSH DE
	CALL DrawTile
	POP DE
	POP BC
;floor
	LD B,8
	LD HL,20704
DrawFloor	
	PUSH BC
	PUSH HL
	LD DE,Floor
	LD BC,4*256+1
	CALL DrawTile
	POP HL
	POP BC
	INC L
	INC L
	INC L
	INC L
	DJNZ DrawFloor
		
	
	RET
;----------------------
RotateAttr
	
	LD D,4; number of Lines to rotate
	LD HL,22944;22528+13*32; ADDress of first Line

RotateAttr2		
	PUSH HL
			
	LD B,31
;rotate one Line of attributes		
	LD C,(HL);Read attr of Leftmost square
	LD A,L
	ADD A,B
	LD L,A;go to Rightmost square
	INC B;b=32	
RotateAttr3	
	LD A,(HL);store attribute of char n to use it with char n-1
	LD (HL),C;write to char n attribute got from char n+1
	LD C,A;stored attr will be used in next iteRation
	DEC L; go to next square			
	DJNZ  RotateAttr3	
		
;go to next Line
	POP HL
	PUSH DE
	LD DE,32; ADDress of next Line
	ADD HL,DE
	POP DE
	DEC D
	JR NZ,RotateAttr2; repeat if there are still Lines Left						
	RET	

;-------------FINAL STAGE START-----------------
FinalStage
 ;set variables
 	LD HL,BossEnergy
 	LD A,10
 	LD (HL),A
 	XOR A
 	LD B,7
SetFinal1
	INC HL
	LD (HL),A
	DJNZ SetFinal1
	LD (PamDeathStatus),A; alive	
	LD (InitialPamFire),A	
	LD (PamBulletStatus),A

 ;Draw Level AND prepare Data
 
 	CALL ClearScreenEffect
 	LD HL,18633
	LD DE,FinalText
	CALL TypeText
	LD BC,5*256+10
	LD DE,PamBig
	LD HL,16384+141
	CALL DrawTile
	LD B,180		
FinalTextDelay
	HALT
	DJNZ FinalTextDelay 
 	
 	
 	
 	CALL ClearScreenEffect
 	CALL DrawFinalStage
 	CALL GameMenu
 ;demo mode, Pamela walking, screen and	attributes scrolling
	LD D,0
	LD BC,768	
	;LD BC,4				
FinalRotate
	PUSH BC
	PUSH DE
	HALT
	CALL MoveBackgroundLeft1; skip testing bonduaries, just rotate
	POP DE
	INC D
	LD A,D
	AND 00000111B;d takes value 0-7
	LD D,A
	OR A
	CALL Z,RotateAttr			
	POP BC
	;Pamela walking animation
	LD A,C
	PUSH BC
	PUSH DE
	LD HL,20546
	LD BC,1029 ;4,5	
	AND 00011111B
	OR A
	JR Z,FinalRotate2	
	CP 16
	JR Z,FinalRotate3
	JR FinalRotate4				
FinalRotate2	
	CALL PamWalkRFrame1
	JR FinalRotate4	
FinalRotate3	
	CALL PamWalkRFrame2	
FinalRotate4	
	POP DE
	POP BC
	DEC BC		
	LD A,B
	OR C
	JR NZ,FinalRotate
			
;boss appears
	LD HL,18464
	LD DE,BossFinalText
	CALL TypeText	
			
	LD BC,154
	;LD BC,12
BossAppear1
	PUSH BC
	HALT
	HALT						
	BIT 0,C ;determine if boss should appear OR disappear
	JR Z,BossDisappear
		
BossAppear2
	;clear text AND Draw boss
	LD HL,22816
	LD B,64	
	XOR A	
BossAppear25
	LD (HL),A
	INC L
	DJNZ BossAppear25			
			
	LD DE,BossStand
	LD BC,4*256+5
	LD HL,20569
	CALL DrawTile
	JR BossAppear4
			
BossDisappear
	;Draw text AND clear boss
	LD HL,22816
	LD B,64	
	LD A,67	
BossDisappear2
	LD (HL),A
	INC L
	DJNZ BossDisappear2		
		
	LD B,5
	LD C,0	
	LD HL,23130	
BossDisappear3
	LD (HL),C
	INC L
	LD (HL),C
	INC L
	LD (HL),C	
	LD A,L
	ADD A,30
	LD L,A
	DJNZ BossDisappear3
 		
BossAppear4
	POP BC
	DEC BC
	LD A,B
	OR C
	JR NZ,BossAppear1		
		
;------------------FINAL LOOP-------------

FinalLoop
	

	LD A,(BossDeadStatus)
	OR A
	JP NZ,BossDead

	LD HL,GameCycle
	INC (HL)
	HALT
	
	CALL PamAction
	CALL PamBulletFinal
	CALL BossAction
	CALL BulletHitsPamela
	
	LD A,(PamDeathStatus)
	OR A
	JP NZ,PamDie
	
	JR FinalLoop	
;-----------BOSS ACTION----------------------------					
BossAction
	LD HL,GameCycle
	LD A,(HL)
	AND 00000111b
	OR A
	RET NZ;it's not action cycle now


;draw boss with appropriate sprite
	LD HL,BossFireHighStatus
	LD A,(HL)
	OR A
	JR NZ,BossFireHigh

	LD HL,BossFireLowStatus
	LD A,(HL)
	OR A
	JR NZ,BossFireLow
	
BossStanding
	LD DE,BossStand	
	JR DrawBoss
	
BossFireHigh
	XOR A
	OUT (254),A;sound
	DEC (HL); decrease time when boss will be in firing position
	LD DE,BossStandAttack
	JR DrawBoss
	
BossFireLow
	XOR A
	OUT (254),A;sound
	DEC (HL)
	LD DE,BossCrouchAttack

DrawBoss
	LD BC,4*256+5
	LD HL,20569
	CALL DrawTile
	
	LD A,16
	OUT (254),A;sound
;-------------------------------
;draw boss bullets
	;BULLET 1
	LD A,(BossBullet1Status)
	OR A ; check if bullet exists
	PUSH AF
	CALL Z,CreateBullet1 ;if bullet doesn't exist try to create it
	POP AF
	JR Z,Bullet1End ;if bullet doesn't exist don't do anything with it
	
	;we know now that bullet exists but it could reach the edge of screen
	;if so we must destroy it
	LD HL,BossBullet1Pos
	LD A,(HL)
	AND 00011111b ;extract number 0-31 - horizontal position
	OR A
	PUSH AF
	CALL Z, DestroyBullet
	POP AF
	OR A
	JR Z,Bullet1End ;if bullet doesn't exist skip the code
	
	;if bullet exists the following code will be executed
	;now we need to move bullet
	LD HL,BossBullet1Pos
	CALL MoveBullet

Bullet1End
	
	;BULLET 2
	LD A,(BossBullet2Status)
	OR A ; check if bullet exists
	PUSH AF
	CALL Z,CreateBullet2 ;if bullet doesn't exist try to create it
	POP AF
	RET Z ;if bullet doesn't exist don't do anything with it
	
	;we know now that bullet exists but it could reach the edge of screen
	;if so we must destroy it
	LD HL,BossBullet2Pos
	LD A,(HL)
	AND 00011111b ;extract number 0-31 - horizontal position
	OR A
	PUSH AF
	CALL Z, DestroyBullet
	POP AF
	OR A
	RET Z;if bullet doesn't exist skip the code
	
	;if bullet exists the following code will be executed
	;now we need to move bullet
	LD HL,BossBullet2Pos
	CALL MoveBullet
	
	RET; dealing with boss bullets is finished

;----------------
DestroyBullet
    ;hl contains bullet position address
	;clears bullet
    XOR A
    LD D,90
    LD E,(HL) ;de loaded with bullet attribute address
    
    LD (DE),A ;clears bullet
    INC DE
    LD (DE),A
    INC DE
    LD (DE),A
    INC DE
    
    INC HL; hl points now to bullet status
    LD (HL),A ;status=0, bullet doesn't exist
    
	RET
;----------------
MoveBullet
 ;clears,moves and redraws bullet which position address is stored in HL

	;clear bullet  right part
	PUSH HL
	LD A,(HL)
	INC A
	INC A; go to rightmost char of bullet
	LD H,90
	LD L,A ;attribute address
	LD (HL),0 ;black space
	POP HL

	DEC (HL);change bullet position	
	
; draw bullet	
	LD A,(HL)
	LD H,80
	LD L,A ;hl loaded with bullet position
	LD BC,3*256+1
	LD DE,BossBullet
	CALL DrawTile
	RET	
;-----------------
CreateBullet1
	LD HL,BossBullet1Pos
	LD DE,BossBullet2Pos
	JR CreateBullet
;-----	
CreateBullet2
	LD HL,BossBullet2Pos
	LD DE,BossBullet1Pos
	JR CreateBullet
;-----	
CreateBullet
	;hl contains boss bullet position address

	;boss can fire two bullet at once. A bullet can be created only if another bullet 
	;-doesn/t exists OR
	;-has been fired some time ago
	;so we need to check the position of another bullet, if it is close to boss
	;it means it has been fired recently, so don't fire another bullet yet


	;check if we should really create new bullet?
	LD A,(DE)
	AND 00011111b
	CP 13;check position of another bullet
	RET NC; if another bullet is close to boss, don't create THIS bullet yet

	LD A,1
	INC HL; got to bullet status
	LD (HL),A ; change status to existing
	DEC HL; back to position
		
	;decide randomly if shooting high or low
	CALL Random
	BIT 5,A
	JR Z,CreateBulletLow
	
CreateBulletHigh
	LD A,4
	LD (BossFireHighStatus),A
	;new bullet postion close to enemy finger
	LD (HL),119

	;high or very high - another random choice
	CALL Random
	BIT 6,A
	RET Z

	LD (HL),87;very high	
	RET
	
CreateBulletLow
	LD A,4
	LD (BossFireLowStatus),A
	;new bullet postion close to enemy finger
	LD (HL),151
		
	;low or very low - another random choice
	CALL Random
	BIT 6,A
	RET Z
	LD (HL),183;very low	
	RET
;---------------
BulletHitsPamela
	
	LD HL,BossBullet1Status
	CALL BulletHitsPamela2	;check if 1st bullet hits Pamela
	LD HL,BossBullet2Status
	CALL BulletHitsPamela2 ;check if 2nd bullet hits Pamela
	RET
;----	
BulletHitsPamela2	
	LD A,(HL)
	OR A ; check status if bullet exists
	RET Z ;finish if bullet doesn't exist
	DEC HL; hl points to bullet position now
	
	LD A,(HL)
	AND 00011111b ;extract bullet horizontal position 0-31
	
;check cooridnates
	CP 5; is position bigger than 4=Pamela position?
	RET NC;no carry means it is bigger, so end checking
	OR A ;bullet at position 0 means it has already passed Pamela
	RET Z
	
;now we know that the horizontal coordinates of bullet and Pamela are equal
;so we must check Y  of bullet position and whether Pamela evaded it	
	LD A,(HL)
	CP 70 ;less than 70 means the bullet is in high top position
	JR C, HighBullet
	CP 160;more than 160 means the bullet is in very low position
	JR NC,LowBullet
	JR BulletDeath ;otherwise the bullet is in miiddle position, so Pamela couldn't evade it
	
HighBullet	
	LD A,(CrouchStatus);croucHing=avoid BULLET
	OR A	
	RET NZ;croucHing,not Die
	JR BulletDeath

LowBullet
	LD A,(PamJumpTime)
	OR A
	RET NZ ;Pamela jumping=not dead	
	JR BulletDeath
	
BulletDeath
	LD A,1
	LD (PamDeathStatus),A;set status to Dead
	RET
;--------------
BossEnergy .BYTE 0
BossDeadStatus .BYTE 0

BossFireHighStatus .BYTE 0
BossFireLowStatus .BYTE 0

BossBullet1Pos .BYTE 0
BossBullet1Status .BYTE 0
BossBullet2Pos .BYTE 0
BossBullet2Status .BYTE 0
;---------------PAMELA ACTION--------------------
PamAction
	LD HL,GameCycle
	LD A,(HL)
	AND 00000111b
	OR A
	RET NZ;it's not action cycle now

;PAMELA FIRING		
;check if firing bullet, if so, can't do anything else
	LD HL,InitialPamFire
	LD A,(HL)
	OR A
	JR Z,AnimatePamela2Final;no firing
	
	DEC (HL);decrease firing Time
	JR Z,PamFinishFireFinal 
	
	LD A,(HL)
	CP 1
	RET NZ ;pamela shooting so don't do anything else and return
	;firing almost finished, Restore non firing frame	
	PUSH IX;frame to be Restored was stored in IX
	POP DE
	
	LD HL,20546 
	LD BC,1029 ;4,5
	CALL DrawTile	
	RET
	
	; firing finished	
PamFinishFireFinal	
	DEC HL;go to bullet status
	LD A,1
	LD (HL),A ;Change  bullet status to make bullet appear
	RET	
;------------------		
AnimatePamela2Final
	;PAM JUMPING
	;check if jumping, if so, also can't do anything else	
	LD HL,PamJumpTime
	LD A,(HL)
	OR A
	JR Z,AnimatePamela3Final ;no jumping		
	
	PUSH HL
	;Draw jumping frame
	LD DE,PamJumpR
	LD HL,20514 
	LD BC,1030 	
	CALL DrawTile
	
	POP HL;Restore jump Time		
		
	DEC (HL);decrease jumping Time
	RET NZ; jumping, cant do anything else so Return from control routine
	
	;End of jump
	;clear upper Line of Pamela
	XOR A
	LD HL,23075
	LD (HL),A
	INC HL
	LD (HL),A
	;Draw Pam Standing(facing Left OR Right)
	LD HL,20546
	LD BC,1029 ;4,5
	PUSH IX
	POP DE; put IN DE frame stored IN IX
	CALL DrawTile			
	RET			
;----------------------
;SCAN KEYBOARD
		
AnimatePamela3Final				
	;check, joystick OR keyboard used for control
	LD A,(GameControl)
	OR A
	JR Z,	KeyboardControlFinal
		
JoystickControlFinal
	LD BC,31
	IN A,(C)
	JR PamelaActionsFinal			
	
		
KeyboardControlFinal
	;the aim is to Set bits of A as it would be joystick
	LD D,0
	LD BC,57342; o,p	
	IN A,(C)
	CPL
	AND 00000011;B
	LD D,A
	LD BC,64510;q
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	OR D		
	LD D,A		
	LD BC,65022;A
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	OR D
	LD D,A
	LD BC,32766
	IN A,(C)
	CPL
	AND 4
	RLA
	RLA
	OR D ;BIT set Ready
		
PamelaActionsFinal
	;Reads either from joystick or keyboard what Pamela should do
	;action pattern is is A		
	PUSH AF
	OR A ;nothing	
		CALL Z,StandFinal
	POP AF	
	PUSH AF
	BIT 2,A
		CALL NZ,CrouchFinal
	POP AF
	PUSH AF
	BIT 4,A
		CALL NZ,PamFireFinal
	POP AF	
	BIT 3,A
		CALL NZ,BeginJumpFinal	
	RET
	
;-----Pamela actions-----		
StandFinal		
	XOR A;Set crouch to 0 
	LD (CrouchStatus),A
	LD HL,20546	
	LD DE,PamWalkR2
	LD BC,1029 ;4,5
	CALL DrawTile
	RET
;--------
CrouchFinal
	;check if firing,if so execute another piece of code
	BIT 4,A
	RET NZ
		
	LD A,1
	LD (CrouchStatus),A;set crouch to 1
			
	LD HL,20546; position
	LD BC,1029 ;4,5
	LD DE,PamCrouchR
	CALL DrawTile
	RET
;-------
PamFireFinal
		
;set crouch status if fire when crouching
	BIT 2,A
	JR Z,PamFire2Final
	LD A,1
	LD (CrouchStatus),A;set crouch to 1	if needed	
		
PamFire2Final		
	
	;fire only if bullet don't exist
	LD A,(PamBulletStatus)
	OR A
	RET NZ ;if bullet exist don't shoot another bullet
		
	LD HL,20546
	LD BC,1029 ;4,5	
;------
PamFireRightFinal
	LD A,(CrouchStatus)
	OR A
	JR NZ,PamFireRightCrouchFinal
	
	LD IX,PamWalkR1; store in IX frame after firing
	LD DE,PamFireStandR
	CALL DrawTile	
	LD A,101
	CALL CreatePamBulletFinal
	RET
		
PamFireRightCrouchFinal
	LD IX,PamCrouchR; store in IX frame after firing
	LD DE,PamFireCrouchR
	CALL DrawTile	
	LD A,133 ;bullet Initial pos
	CALL CreatePamBulletFinal
	RET

;----------
CreatePamBulletFinal
	LD HL,PamBulletL
	LD (HL),A;write position
	DEC HL
	LD A,(Direction)
	LD (HL),A ;BulletDirection=PamDirection
	DEC HL			
	LD A,3
	LD (HL),A ;set Initial fire to 4 frames,firing animation
	RET
;------------------
BeginJumpFinal
	LD A,(CrouchStatus)
	OR A
	RET NZ ;no jumping when croucHing
		
	LD A,8
	LD (PamJumpTime),A
	
	LD DE,PamJumpR
	LD IX,PamWalkR1
	;Draw jumping frame
	LD HL,20514
	LD BC,1030 	
	CALL DrawTile	
	RET
;--------Pamela bullet---------------------------

PamBulletFinal
	LD HL,GameCycle
	LD A,(HL)
	AND 00000111b
	OR A
	RET NZ;it's not action cycle now
	
	LD A,(PamBulletStatus)
	OR A
	RET Z; status=0 means no bullet so return

	;Drawing Pamela bullet
	
	;bullet dissapear at old position
	LD H,90
	LD A,(PamBulletL)
	LD L,A
	XOR A	
	LD (HL),A
		 			
	;new bullet position
	LD HL,PamBulletL
	INC (HL)

	;display bullet 
	LD L,(HL)
	LD H,80 ;position
	LD DE,PamBullet
	LD BC,257 ;1,1
	CALL DrawTile ;Drawing bullet

	CALL BulletsMeet;check collision of bullets 

	;check if bullet hit boss
	LD A,(PamBulletL)
	CP 123
	JR Z,BulletHitBoss
	CP 155
	JR Z,BulletHitBoss
	RET
		
;-------		
BulletHitBoss		
	
	XOR A
	LD (PamBulletStatus),A;bullet status=0,kill Pamela bullet
	
	;decrease boss energy
	LD HL,BossEnergy
	DEC (HL)
	RET NZ ; boss still alive
	
	LD A,1
	LD (BossDeadStatus),A; boss dead
	RET
		
;-----------------
BulletsMeet

;bullets collision may hapen if pamela bullet X position= boss bullet X position
;or pamela bullet pos=boss bullets pos+1 if the bullets don't meet at exact point
;when Pamela bullet hits boss bullet they will anihilate together

;check collision with bullet 1
CheckCollision1	
	LD HL,BossBullet1Status
	LD A,(HL)
	OR A; check if bullet exists
	JR Z,CheckCollision2; if it doesn't exist skip the code

	DEC HL ;go to bullet 1 position
	LD B,(HL)
	LD A, (PamBulletL)
	CP B ;pamela bullet=boss bullet?
	JR Z, Collision1Detected
	INC B
	CP B;pamela bullet=boss bullet+1?
	JR Z,Collision1Detected
	JR CheckCollision2 ;coliision not detected, go check another bullet
	
Collision1Detected	
	;destroy Pamela Bullet
	XOR A
	LD HL,PamBulletStatus
	LD (HL),A;bullet status=0,kill bullet
	
	LD HL,PamBulletL
	LD E,(HL)
	LD D,90
	LD (DE),A; clear Pamela bullet
	;destroy boss bullet
	LD HL,BossBullet1Pos
	CALL DestroyBullet
	
	CALL CollisionSound
	RET
;-------
CheckCollision2	
	LD HL,BossBullet2Status
	LD A,(HL)
	OR A; check if bullet exists
	RET Z; if it doesn't exist skip the code

	DEC HL ;go to bullet 1 position
	LD B,(HL)
	LD A, (PamBulletL)
	CP B ;pamela bullet=boss bullet?
	JR Z, Collision2Detected
	INC B
	CP B;pamela bullet=boss bullet+1?
	JR Z,Collision2Detected
	RET ;coliision not detected, end checking collisions
	
Collision2Detected	
	;destroy Pamela Bullet
	XOR A
	LD HL,PamBulletStatus
	LD (HL),A;bullet status=0,kill bullet
	LD HL,PamBulletL
	LD E,(HL)
	LD D,90
	LD (DE),A; clear Pamela bullet
	;destroy boss bullet
	LD HL,BossBullet2Pos
	CALL DestroyBullet
	
	CALL CollisionSound
	RET

;-------------
Random
	LD	A,0		
	LD	B,A
	ADD	A,A
	ADD	A,A
	ADD	A,B
	INC A
	LD	(Random+1),A
	RET
;----------
CollisionSound
	LD B,150
CollisionSound2	
	XOR A
	OUT (254),A
	LD C,B
CollisionSound3
	NOP
	DEC C
	JR NZ,CollisionSound3		
	LD A,16
	OUT (254),A
	DJNZ CollisionSound2
	RET
;--------
BossDead
	;Play scream	
	LD A,50
	LD (SampleDelay+1),A		
	CALL PlaySample
	
	;increase score
	LD HL,(Score)
	LD DE,100
	ADD HL,DE
	LD (Score),HL

	;boss death animation
	LD DE,BossStand
	LD BC,4*256+5
	LD HL,20569
	CALL DrawTile
	
	LD E,85
	CALL BossDeathAnim	
	LD E,85
	CALL BossDeathAnim	
	LD E,85
	CALL BossDeathAnim	
	LD E,0
	CALL BossDeathAnim
	CALL ClearScreenEffect
	
	JP GameWin	
;---
BossDeathAnim	
	LD HL,20570
	LD C,5
BossDeath1	
	LD B,8
BossDeath2	
		LD D,3
		LD A,E
		OR A
		JR Z,BossDeath3
		LD A,R
		LD E,A
		OR A
		JR NZ,BossDeath3
		LD E,72
BossDeath3
			XOR A
			OUT (254),A
			HALT
			LD A,(HL)
			AND E
			LD (HL),A 
			INC HL
			LD A,16
			OUT (254),A
			DEC D
			JR NZ, BossDeath3
		DEC HL
		DEC HL
		DEC HL
		INC H
		DJNZ BossDeath2
	LD H,80
	LD A,L
	ADD A,32
	LD L,A
	DEC C
	JR NZ,BossDeath1
	RET

	

