

		
        ORG 31500


;StartMenu - Start Menu (control selection,Start Game)
;GameInfo - Pamela story
;Game Menu - Menu during Game (Lives,Score...)
;DrawBack - Draw Background



		
;------------------
StartMenu
		
;keyboard,joystick, Start Game etc.		
	
;DraWing Menu		
	CALL ClearScreen
	;Draw Title
	LD HL,16457
	LD DE,Title
	LD BC,3078 ;12,6
	CALL DrawTile
		
		
	LD HL,20643
	LD DE,StartMenuText2
	CALL TypeText
	
	LD HL,18503
	LD DE,StartMenuText1
	CALL TypeText
		
	;Type HiScore
	LD HL,(HiScore)
	LD (Score),HL
	CALL CountScore
	CALL TypeHiScore
			
	
	CALL 35070 ; music
		
StartMenu2
	LD HL,18503
	LD DE,StartMenuText1
	CALL TypeText
	
StartMenuControl		
;Highlight choosen option
	LD A,(MenuColor1)
	CP 70
	JR Z,HiOption1	
	LD A,70
	JR HiOption2	;Color cycling	
HiOption1		
		LD A,66
HiOption2	
	LD (MenuColor1),A
	LD HL,22855
	;wHich Line Highlight,keyboard OR joystick	
	PUSH AF
	LD A,(GameControl)	
	OR A
	JR Z,HiOption3;keyboard,no Change Line
	
	LD A,L
	ADD A,32;joystick,one Line down
	LD L,A
			
HiOption3
	POP AF
	LD B,19
	HALT
HiOption4
	LD (HL),A
	INC HL
	DJNZ HiOption4		


;testing keyboard
	LD BC,63486
	IN A,(C)
		
	PUSH AF
	BIT 0,A ;choose keys
	JR Z,SetKeys
	POP AF
		
	PUSH AF
	BIT 1,A ;choose joy	
	JR Z,SetJoy
	POP AF
			
	PUSH AF
	BIT 2,A ;Type Introduction
	JP Z,GameInfo
	
	POP AF
	BIT 3,A
	JR NZ,StartMenuControl
	
	;Play scream	
	LD A,50
	LD (SampleDelay+1),A		
	CALL PlaySample
		
	JP StartGame2; Start Game	
		
	JR StartMenuControl
;------		
SetKeys
	XOR A
	LD (GameControl),A;write keys variable
	JR StartMenu2;update Colors	
SetJoy
	LD A,1
	LD (GameControl),A;write keys variable
	JR StartMenu2;update Colors
				
MenuColor1	.BYTE 70		
		
;-------------------------------------		

GameInfo
	;Intro1page
	CALL ClearScreen	
	LD HL,16399
	LD DE,PamNormal
	LD BC,773
	CALL DrawTile
		
	LD HL,16544
	LD DE,IntroText1
	CALL TypeText	
		
	;DisplayIntroText	
	LD HL,22688
	LD BC,607
DisplayIntroText	
	HALT
	LD A,2
	LD (HL),A
	HALT
	LD A,70
	LD (HL),A
	HALT
	LD A,71
	LD (HL),A
		
	INC HL
	DEC BC
	LD A,B
	OR C
	JR NZ,DisplayIntroText	
;Intro2PAGE
	CALL ClearScreen	
	LD HL,18446
	LD DE,PamStand
	LD B,4
	LD C,5 
	CALL DrawTile
	
	LD HL,18600
	LD DE,IntroText2
	CALL TypeText				
	
	;Delay

	LD B,180
Intro2Delay		
	HALT	
	DJNZ Intro2Delay	
	JP StartMenu

;----------------------------

GameMenu

;menu during game		
;Draw title
	LD HL,16393
	LD DE,Title
	LD BC,3078 ;12,6
	CALL DrawTile
;Draw menu texts
	LD HL, 16386
	LD DE,LivesText
	CALL TypeText
		
	LD HL, 16439
	LD DE,DistanceText
	CALL TypeText
		
;colors for distance bar		
	LD HL,22711
	LD A,66
	LD B,8		
DistBarColor
	LD (HL),A
	INC L
	DJNZ DistBarColor

;Type Score
	CALL CountScore		
	CALL TypeScore				
;Draw Chain
	LD HL, 16608
	LD DE,Chain
	LD B,8
DrawChain			
	PUSH HL
	PUSH BC
	PUSH DE				
	LD BC,1026 ;4,2
	CALL DrawTile
	POP DE
	POP BC
	POP HL
	LD A,L
	ADD A,4
	LD L,A
	DJNZ DrawChain
					
;Draw Lives
	LD HL, 16514
	LD DE,Rose
	LD A,(Lives)
	OR A
	RET Z;0 Lives=DON'T Draw Lives
	LD B,A
DrawLives			
	PUSH HL
	PUSH BC
	PUSH DE				
	LD BC,259 ;1,3
	CALL DrawTile
	POP DE
	POP BC
	POP HL
	INC L
	DJNZ DrawLives
								
	RET
;--------------
			
				

DrawDistanceBar

;draWing bar indicating covered distance on the level
;no argument needed		
;Score (0-96)	
	
	LD H,66;score bar screen Left corner
	LD L,183	
	LD A,(Distance)
	
OneDistChar	
	
	CP 8;checks if should draw last bar char
	JR C,LastDistChar; width Left less or equal to 8, draw last not complete char
	JR Z,LastDistChar
	PUSH AF
	LD A,255
	LD B,6
	PUSH HL		
;draw one full score char
OneDistChar2
	LD (HL),A
	INC H		
	DJNZ OneDistChar2
	POP HL
	INC L;go to another char
	POP AF
	SUB 8;width yet to drawn decreased
	JR OneDistChar				
	
LastDistChar
;counts width				
	OR A
	JR Z,EmptyDistChar;no need to draw last char when a=0
	LD B,A
	XOR A	
LastDistChar2
	SCF ;CARRY=1
	RRA ;CreateS E.G. 11100000B

	DJNZ LastDistChar2
			
;Draw LAST ,NOT QUITE FULL Score CHAR
	PUSH HL
	LD B,6
LastDistChar3
	LD (HL),A		
	INC H	
	DJNZ LastDistChar3
	
	
EmptyDistChar
	;Draw EMPTY CHAR ET THE End OF BAR
	;TO DELETE NO MORE NECESSARY BAR PAR IF BAR DECREASED
	POP HL
	INC L
	XOR A	
	LD B,6
EmptyDistChar2
	LD (HL),A		
	INC H	
	DJNZ EmptyDistChar2
	RET
;--------------------------------
CountScore
;routine takes value written in Score or Hiscore variable and displays it into screen
	LD HL,(Score)
;10000
	LD DE,10000
	XOR A
CountScore1		
	INC A
	SBC HL,DE	
	JR NC,CountScore1
	DEC A
	ADD HL,DE
	ADD A,31
	LD (Score1),A
;1000
	LD DE,1000
	XOR A
CountScore2		
	INC A
	SBC HL,DE	
	JR NC,CountScore2
	DEC A
	ADD HL,DE
	ADD A,31
	LD (Score2),A
;100
	LD DE,100
	XOR A
CountScore3		
	INC A
	SBC HL,DE	
	JR NC,CountScore3
	DEC A
	ADD HL,DE
	ADD A,31
	LD (Score3),A
;10
	LD DE,10
	XOR A
CountScore4		
	INC A
	SBC HL,DE	
	JR NC,CountScore4
	DEC A
	ADD A,31
	ADD HL,DE
	LD (Score4),A
;1
	XOR A
	LD DE,1
CountScore5
	INC A
	SBC HL,DE
	JR NC,CountScore5
	DEC A
	ADD A,31
	LD (Score5),A
	RET
TypeScore	
	LD HL,16471
	LD DE,ScoreDecim
	CALL TypeText		
	RET
TypeHiScore
	LD HL,20524
	LD DE,ScoreDecim
	CALL TypeText	
	RET		
;----------------------------
;display time remaining on the level

DisplayTime
	LD HL,TimeCycle
	LD A,(HL)
	INC A
	LD (HL),A; Change time cycle variable (values 0-50)
	CP 50
	JR NZ,DisplayTime2
	;decreasing time
	XOR A
	LD (HL),A; reset cycles to 0
	INC HL
	DEC (HL);decrease proper time
	
			
DisplayTime2		
	LD HL,Time
	LD A,(HL)
	INC HL
;100	
	LD C,31
CountTime1
	INC C
	SUB 100
	JR NC,CountTime1
	DEC C
	ADD A,100
	LD (HL),C
;10
	INC HL
	LD C,31
CountTime2
	INC C
	SUB 10
	JR NC,CountTime2
	DEC C
	ADD A,10
	LD (HL),C
;1	
	INC HL
	ADD A,31
	LD (HL),A
		
	;Type Score
	LD HL,16419
	LD DE,TimeDecim
	CALL TypeText	
	RET
;-------------------
;end of time		
TimeOver
	CALL ClearScreen
	LD HL,18571
	LD DE,TimeOverText
	CALL TypeText

	LD B,180
TimeOverDelay
	HALT
	DJNZ TimeOverDelay
		
	; decrease lives number
	LD HL,Lives	
	DEC (HL)
	LD A,(HL)
	CP 255;check if last life lost, lives<0
	JP Z,GameOver
		
	;reset time and distance
	LD A,1
	LD (Distance),A
	LD (RestoreTime),A
	JP StartLevel	
				
				
;----------------
;Pamela dies	
PamDie
	;scream
	;Play scream	
	LD A,18
	LD (SampleDelay+1),A		
	CALL PlaySample	
	
	XOR A
	OUT (254),A;black border	
	
;fill screen randomly with red chars
;rom Data are used for obtaining random numbers				
	LD DE,0
	LD BC,3000
	
PamDie1	
	LD A,(DE)
	AND 00000011B
	CP 3
	JR Z,PamDie2
		
		
	ADD A,88
	LD H,A
	INC DE
	LD A,(DE)
	LD L,A; hl loAded with random screen char ADDress	
	LD A,18
	LD (HL),A

	
	PUSH BC
	LD B,180
PamDieDelay		
	DJNZ PamDieDelay	
	POP BC
		
PamDie2	
	INC DE		
			
	DEC BC
	LD A,B
	OR C
	JR NZ,PamDie1	
		
;some chars are still not red, correct it
	LD A,18
	LD HL,22528
	LD (HL),A
	LD DE, 22529
	LD BC, 767;grapHics+attr
	LDIR
	LD A,2
	OUT (254),A	
;wait a little bit		
	LD B,60
PamDieDelay2
	HALT
	DJNZ PamDieDelay2	
		
	; decrease lives number
	LD HL,Lives	
	DEC (HL)
	LD A,(HL)
	CP 255;check if last life lost, lives<0
	JR Z,GameOver
		
	XOR A
	LD (RestoreTime),A; do not restore time
	
	CALL ClearScreen
	
	LD A,(Stage)
	CP 7
	JP Z,FinalStage; if stage=7 after death go to final battle
	
	JP StartLevel1 ; otherwise go to level beginning
;------------
GameOver
	CALL ClearScreen
	LD HL,18571
	LD DE,GameOverText
	CALL TypeText

	LD B,180
GameOverDelay
	HALT
	DJNZ GameOverDelay
	
	;update Hiscore if necessary
	LD DE,Score+1
	LD HL,HiScore+1
	;compare bigger byte
	LD A,(DE)
	LD B,(HL)
	CP B; count score-Hiscore
	JR C,NoNewHiScore;HiScore BIGGER THAN Score
	JR NZ,NewHiScore		
	;BIGGER BYTE HiScore=BIGGER BYTE Score(SO ZERO FLAG SET), SO COMPARE SMALLER BYTE
	DEC DE
	DEC HL
	LD A,(DE)
	LD B,(HL)
	CP B
	JR C,NoNewHiScore
NewHiScore
	;write score to highscore
	LD HL,(Score)
	LD (HiScore),HL		
		
NoNewHiScore		
	JP StartGame1				


;-----------
NewLevel
	LD A,1
	LD (Distance),A
	LD (RestoreTime),A;Restore Time
		
	LD HL,Stage 
	INC (HL)
	LD A,(HL)
	CP 7
	JP Z,FinalStage	
			
	JP StartLevel	
;------------
GameWin
	CALL ClearScreen
	LD HL,18446
	LD DE,PamStand
	LD BC,1029
	CALL DrawTile
		
	LD HL,18629
	LD DE,GameWinText
	CALL TypeText
	
	;DisplayWinText	
	LD HL,22975
	LD B,255
DisplayWinText	
	HALT
	LD A,2
	LD (HL),A
	HALT
	HALT
	LD A,70
	LD (HL),A
	HALT
	HALT
	LD A,71
	LD (HL),A
		
	INC HL
	DJNZ DisplayWinText
	JP GameOver	
							
		
;--------------------------------
DrawTile
;first 2 sprite bytes contain size of the sprite
;bc - size
;de memory ADDress
;hl - position

				
; stores ADDress of sprite in screen-hl and its size-bc for further use
;by attributes routine
	PUSH HL
	PUSH BC			
	
;this loop draw "c" Lines of chars
DrawTile1		PUSH HL
			PUSH BC
		
;this loop4 draws one Line of chars
DrawTile2
			PUSH HL
				
					LD A, (DE)
					CP 16	  ; number 16 codes empty char
					 	  ; when it is detected program jumps to another char
						  ; this routine saves Data space	
					JR NZ, DrawTile3 ; when first byte is not 16 should draw a char
					
					INC DE ; when fisrt byte is 16 it is an empty char
					JR DrawTile4 ; so skip it and go to next char 
							; (we must increase Data ADDress by one)						
					
;this loop draws one char
DrawTile3			LD A, (DE)
					LD (HL),A ;repeated 8 times, quicker than a loop
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC DE
						
DrawTile4		LD A,L
				POP HL ;restores h to ADDress of upper row of the Line
				LD L,A
				INC L	;Moves one char Right 
					 
				DJNZ DrawTile2 
			POP BC
			POP HL		
			; goes to another Line of chars in the sprite
			LD A,L
			ADD A,32
			LD L,A
			JR NC,DrawTile5;not carry=no going to next segment, so no h Changes needed
				
				;Change h only if going to next screen segment	
				LD A,H
				ADD A,8
				LD H,A
					
DrawTile5			
			DEC C ;decrease number of chars Line in sprite yet to do
			JR NZ, DrawTile1
		
; drawing Tile is finished
; now restores size of the Tile in bc, its corner in hl
;  de is alReady increased to next byte where attributes Data begin
						
		POP BC
		POP HL		
						
		
;attributes
;bc should contain sprite size (b-width c-height)
;de should contain start of attributes Data		
;hl should contain ADDress of firt byte of attr		
	
;transforms point ADDress to attribute ADDress
		
TileAttrS		
		;if first byte of attributes set to 255->don't draw attributes
		;(useful with Background)
		LD A,(DE)
		CP 255
		RET Z
		
		
		LD A,80
		SRL H
		SRL H
		SRL H
		ADD A,H
		LD H,A
			
;loop1 draw c Lines of attributes
TileAttr1 	PUSH BC
		PUSH HL
		
;loop2 draw one Line of attributes
TileAttr2   LD A,(DE);Read attr
		LD (HL),A; write attr
TileAttr3	INC HL ;goes to next square in the row
		INC DE
		DJNZ TileAttr2
	
		POP HL
		PUSH DE ;    goes to
		LD DE,32 ;   next row
		ADD HL,DE ;  of 
		POP DE ;	 attributes	
		POP BC
		DEC C ;decreases number of Lines yet to do 
		JR NZ, TileAttr1
		
		RET
;------------------------
MoveBackgroundRight
;rotates Background one pixel Right	
	;check if should rotate Background
	LD A,(Distance)
	CP 1
	JR NZ,MoveBackgroundRight1 ; position not at edge of level,scroll for sure
	LD A,(LevelDirection)
	OR A
	RET NZ; going right and standing on left edge=not scroll
MoveBackgroundRight1 		
	;rotate upper background
	LD HL,18592;rotated block left upper corner
	LD D,4 ;number of char Lines	
	CALL MoveBackgroundRight2 	
	;rotate Bottom Line twice
	LD HL,20704
	LD D,1
	CALL MoveBackgroundRight2
	LD HL,20704
	LD D,1
	CALL MoveBackgroundRight2		
		
	RET
			
MoveBackgroundRight2			
BackRight1
	PUSH HL	;rotate one char Line,8Lines
	LD B,8
	
;----move one Line-----		
BackRight2		
	PUSH HL
	;rotate most right byte
	LD A,L
	ADD A,31
	LD L,A
	LD A,(HL)
	RRA ; rotates most right byte, not is screen but virtually
		;that sets carry flag appropraitely to be used by most left byte	
	POP HL
	
	PUSH HL
	;rotate one Line
		RR (HL);rotate one byte
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L;10
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L;20
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L;32

;-------	
	POP HL;Restore L
	INC H
	DJNZ BackRight2	
	;next char Line
	POP HL
	LD A,L
	ADD A,32
	LD L,A
	JR NC,BackRight4
	LD A,H
	ADD A,8
	LD H,A	;next screen segment
BackRight4			
	DEC D
	JR NZ,BackRight1		
	RET
		
;------------------
MoveBackgroundLeft
;rotates background one pixel right	
	;check if should rotate background
	LD A,(Distance)
	CP 1
	JR NZ,MoveBackgroundLeft1 ; position not at edge of level,scroll for sure
	LD A,(LevelDirection)
	OR A
	RET Z; going left and standing on right edge=not scroll
		
MoveBackgroundLeft1	
	;rotate upper background
	LD HL,18623;rotated block right upper corner
	LD D,4 ;number of char Lines
	CALL MoveBackgroundLeft2
	;rotate Bottom Line twice
	LD HL,20735
	LD D,1
	CALL MoveBackgroundLeft2
	LD HL,20735
	LD D,1
	CALL MoveBackgroundLeft2
	RET	
		
MoveBackgroundLeft2
	
BackLeft1
	PUSH HL	;rotate one char Line,8Lines
	LD B,8
	
;----ONE Line-----		
BackLeft2		
	
	;rotate most left byte
	PUSH HL
	LD A,L
	SUB 31
	LD L,A;go to most left byte
	LD A,(HL)
	RLA ; rotates most left byte, not is screen but virtually
		;that sets carry flag appropraitely to be used by most right byte	
	POP HL
	PUSH HL
		;rotate one Line

	RL (HL);rotate one byte
	DEC L
	RL (HL)
	DEC L	
	RL (HL)
	DEC L	
	RL (HL)
	DEC L
	RL (HL)
	DEC L		
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L	
	RL (HL)
	DEC L		
	RL (HL)
	DEC L	;10
		
	RL (HL)
	DEC L	
	RL (HL)
	DEC L	
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L ;20
		
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L;32

;-------	
	POP HL;Restore L
	INC H
	DJNZ	BackLeft2	
	;next char Line
	POP HL
	LD A,L
	ADD A,32
	LD L,A
	JR NC,BackLeft4
	LD A,H
	ADD A,8
	LD H,A	;next screen segment
BackLeft4			
	DEC D
	JR NZ,BackLeft1		
	
	RET		
;------Text------------
TypeText	
; this routine types text

;hl contains position of text on screen
;de contains text ADDress in memory
;bc is used		

	;default text color is white on black
	LD A,71
	LD (TextColor),A
		
	LD (TextLineAd),HL
	
Text1	
	;check if end of string
	LD A,(DE)
	OR A
	JR Z,TextEnd ;end of text if zero
	
	CP 63; checks if should go to new line
	JR Z,TextNewLine
	CP 51; checks if color change
	JR Z,TextColorChange
	;letter attribute	
	PUSH HL
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A
	LD A,(TextColor)
	LD (HL),A ;load attribute into char
	POP HL
	;draw a letter
	LD A,(DE)	;code of letter loAded
	LD BC,Letters-8;start of Letters sprites
	
	;count Address of letter
	SLA A
	SLA A
	SLA A		;a=a*8 (with carry)to count Adress of letter		
	
	PUSH HL
	LD HL,0
		
	LD L,A
	LD A,0
	ADC A,H	
	LD H,A	;HL=A*8	
	ADD HL,BC
	LD B,H
	LD C,L	;bc loAded with letter sprite ADDress
	POP HL
		
				;Address of printed letter placed in bc
	
Text2		
	PUSH HL
	PUSH DE
	LD E,8
Text3	LD A,(BC)	;Read letter Data
	LD (HL),A	;and print it in screen		
	INC H
	INC BC	;go to another byte
	DEC E
	JR NZ, Text3
	POP DE
	POP HL

;go to another letter			
	INC L	;next char on the screen
	INC DE ;next letter
	JR Text1
		
TextNewLine
	;this subroutine goes one line down	with text
	LD HL,(TextLineAd)	;beginning of current line in hl
	CALL CountNextLine	;count ADDress of one line down and place it in hl
	LD (TextLineAd),HL	;update value
	INC DE			;next letter
	JR Text1			;go to letter printing routine
TextColorChange
	INC DE
	LD A,(DE);Read new color
	LD (TextColor),A; and write it to proper cell			
	INC DE; go to next letter
	JR Text1
;---------
CountNextLine
	;routine takes hl ADDress of screen byte and counts ADDress of byte one line lower
	LD A,L
	ADD A,32
	LD L,A; go to next line
	RET NC; if no next screen segment,just return
		;go to next screen segment if needed
		LD A,H
		ADD A,8
		LD H,A
	RET		
				
TextEnd RET	
TextColor .BYTE 71; this cell stores Text attribute
TextLineAd .WORD 16384;tHis 2 cells store screen ADDress 
			   ;of currently printed Text Line (ADDress of 1st char, to be exact)	
		
;----------------------------
ClearScreen
	XOR A
	OUT (254),A ;black border
	LD HL,16384
	LD (HL),A
	LD DE, 16385
	LD BC, 6911;grapHics+attr
	LDIR
	RET
;---------	
;slowly fading screen	
ClearScreenEffect
 XOR A
 OUT (254),A ;black border
 LD D,127
 LD E,8
 
CSE2
 LD HL,16384		 
 HALT
 HALT
 HALT
 HALT
 LD C,32
 LD B,192					
CSE3
 LD A,(HL); one step of clearing screen
 AND D
 LD (HL),A
 INC HL
 DJNZ CSE3
 
 LD B,192
 DEC C
 JR NZ, CSE3		
 
 SCF
 CCF
 RR D
 DEC E
 JR NZ,CSE2		
 RET
;---------------------


